<?php

require_once("lib/villagenav.php");

function questbook_getmoduleinfo(){
	$info = array(
		"name"=>"Quest Book",
		"version"=>"1.0",
		"author"=>"XChrisX",
		"category"=>"Quest",
		"download"=>"http://beta.lotgd.de/downloads/questpack.zip",
		"requires"=>array(
			"questbasics" => "1.0|XChrisX, http://beta.lotgd.de/downloads/questpack.zip",
		),
	);
	return $info;
}

function questbook_install(){
	module_addhook("footer-prefs");
	module_addhook("bioinfo");
	return true;
}

function questbook_uninstall(){
	return true;
}

function questbook_dohook($hookname,$args){
	global $session, $REQUEST_URI;
	$userid = $session[user][acctid];
	$argsid = $args[acctid];
	$argsname = $args[login];
	switch ($hookname) {
		case "footer-prefs":
			addnav("Quests");
			addnav("Questbook", "runmodule.php?module=questbook&user=$userid&return=".$_SERVER['REQUEST_URI']);
			break;
		case "bioinfo":
			if ((int)get_module_pref("questscompleted", "questbasics", $args[acctid]) > 0)
				addnav("Questbook", "runmodule.php?module=questbook&user=$argsid&username=$argsname&return=".URLencode($_SERVER['REQUEST_URI']));
			break;
	}
	return $args;
}

function questbook_run(){
	global $session;

	$return = httpget('return');
	$return = cmd_sanitize($return);
	$return = substr($return,strrpos($return,"/")+1);
	tlschema("nav");
	addnav("Return whence you came",$return);
	tlschema();

	$userid = httpget("user");
	$strike = false;

	if ($session[user][acctid] == $userid) {
		page_header("The Questbook");
		$currentquest = get_module_pref("questinprogressname", "questbasics", $userid);

		$sql = "SELECT * FROM quests WHERE queststation = 0 AND questname = '$currentquest'";
		$row = db_fetch_assoc(db_query($sql));
		$questname = $row[questdescription];
		output("$questname`n");

		$sql_current = "SELECT * FROM questlog WHERE userid = $userid AND questname = '$currentquest' ORDER BY queststation DESC";
		$result = db_query($sql_current);
		for ($i=0; $i < db_num_rows($result); $i++) {
			$row = db_fetch_assoc($result);
			$station = $row[queststation];
			$name = $row[questname];
			$sql = "SELECT * FROM quests WHERE queststation = $station AND questname = '$name'";
			$row = db_fetch_assoc(db_query($sql));
			$queststationdescription = $row[questdescription];
			if ($strike) rawoutput("<s>");
			output("`7$queststationdescription`0");
			if ($strike) rawoutput("</s>");
			output_notl("`n");
			$strike = true;
		}
	} else {
		$username = httpget("username");
		page_header("The Questbook of $username");
		page_header("The Questbook of %s",$username);
	}

	$sql_finished = "SELECT * FROM questlog WHERE userid = $userid AND queststation < 0 ORDER BY reachingdate DESC";
	$result = db_query($sql_finished);
	for ($i=0; $i < db_num_rows($result); $i++) {
		$row = db_fetch_assoc($result);
		$station = $row[queststation];
		$name = $row[questname];
		$sql = "SELECT * FROM quests WHERE queststation = 0 AND questname = '$name'";
		$row = db_fetch_assoc(db_query($sql));
		$questname = $row[questdescription];
		$sql = "SELECT * FROM quests WHERE queststation = $station AND questname = '$name'";
		$row = db_fetch_assoc(db_query($sql));
		$queststationdescription = $row[questdescription];
		output("$questname`n");
		output("$queststationdescription");
		output_notl("`n`n");
	}
	page_footer();
}
?>